Unit sf36e_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, SF23Z_p, UTSF13_p;

function sf36e(X :Extended; var A :Extended; var B :Extended;
                var IERR :Integer): Extended;

implementation

function sf36e(X :Extended; var A :Extended; var B :Extended;
                var IERR :Integer): Extended;
var
IB,IERR1,INT :Integer;
PS,PX,Y,P1,DA,XINT,CNT,WH,XB,DB,C,TOT,RAB,D4,TEMP,EPS2,R1,R2,
   PQ :Extended;
const
SYS089 :Real = 1.0e-15;
SYS059 :Real = 1.7E38;
SYS055 :Real = 2.2251e-308;
SYS077 :Real = -7.44440072e+2;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14;
begin
{ Result -    SF36E  FORTRANe }
Y := X;
if ( (X <= 1.0e0) ) and ( (X >= 0.0e0) ) 
 then goto _1;
IERR := 65;
goto _13;
_1:
if ( (A > 0.0e0) ) and ( (B > 0.0e0) ) 
 then goto _2;
IERR := 66;
goto _13;
_2:
IERR := 0;
EPS2 := SYS089;
if ( X > 0.5e0 ) 
 then goto _3;
INT := 0;
goto _4;
_3:
INT := 1;
TEMP := A;
A := B;
B := TEMP;
Y := 1.e0-Y;
_4:
if ( X <> 0 ) and ( X <> 1.e0 ) 
 then goto _5;
Result := 0.e0;
goto _12;
_5:
IB := Trunc( B );
TEMP := IB;
PS := B-(IB);
if ( B = TEMP ) 
 then PS := 1.e0;
DA := A;
DB := B;
PX := DA*Ln(Y);
SF23Z(DA+DB,0.e0,PQ,RAB,EPS2,0,IERR1);
EPS2 := SYS089;
SF23Z(DA,0.e0,P1,RAB,EPS2,0,IERR1);
EPS2 := SYS089;
SF23Z(DB,0.e0,C,RAB,EPS2,0,IERR1);
D4 := Ln(DA);
EPS2 := SYS089;
SF23Z(PS+DA,0.e0,R1,RAB,EPS2,0,IERR1);
EPS2 := SYS089;
SF23Z(PS,0.e0,R2,RAB,EPS2,0,IERR1);
XB := PX+R1-R2-D4-P1;
IB := Trunc( XB/SYS077 );
XINT := 0.e0;
if ( IB <> 0 ) 
 then goto _7;
XINT := Exp(XB);
CNT := XINT*DA;
WH := 0.e0;
_6:
WH := WH+1.e0;
CNT := CNT*(WH-PS)*Y/WH;
XB := CNT/(DA+WH);
XINT := XINT+XB;
if ( XB/SYS089 > XINT ) 
 then goto _6;
_7:
TOT := 0.e0;
if ( DB <= 1.e0 ) 
 then goto _11;
XB := PX+DB*Ln(1.e0-Y)+PQ-P1-Ln(DB)-C;
IB := Trunc( XB/SYS077 );
if ( IB < 0 ) 
 then IB := 0;
C := 1.e0/(1.e0-Y);
CNT := Exp(XB-(IB)*SYS077);
PS := DB;
WH := DB;
_8:
WH := WH-1.e0;
if ( WH <= 0.0e0 ) 
 then goto _11;
PX := (PS*C)/(DA+WH);
if ( PX > 1.e0 ) 
 then goto _9;
if ( CNT/SYS089 <= TOT ) or ( CNT <= SYS055/PX ) 
 then goto _11;
_9:
CNT := CNT*PX;
if ( CNT <= 1.e0 ) 
 then goto _10;
IB := IB-1;
CNT := CNT*SYS055;
_10:
PS := WH;
if ( IB = 0 ) 
 then TOT := TOT+CNT;
goto _8;
_11:
Result := TOT+XINT;
_12:
if ( INT = 0 ) 
 then goto _14;
Result := 1.e0-Result;
TEMP := A;
A := B;
B := TEMP;
goto _14;
_13:
UTSF13(IERR,36);
Result := SYS059;
_14:
exit;
end;

end.
